#include "U8glib.h"

U8GLIB_SSD1306_128X64 u8g(U8G_I2C_OPT_NONE);        // HW SPI Com: CS = 10, A0 = 9 (Hardware Pins are  SCK = 13 and MOSI = 11)
//-------字体设置，大、中、小
#define setFont_L u8g.setFont(u8g_font_7x13)
#define setFont_M u8g.setFont(u8g_font_fixed_v0r)
#define setFont_S u8g.setFont(u8g_font_chikitar)

#include <iterator>
#include <string>
#include <pnew.cpp>

//=============================
#define INTERVAL_LCD             100
#define INTERVAL_LCD_SWITCH      2000
#define INTERVAL_SENSOR          500

//*60*2

unsigned long updata_time=millis();
unsigned long lcd_time=millis();
unsigned long lcd_switch_time=millis();
unsigned long sensor_time=millis();

int lcd_switch_num=0;

//=============================
#include <Wire.h>

#include <AM2321.h>
AM2321 am2321;

#include <Adafruit_BMP085.h>
Adafruit_BMP085 bmp;

#include <Adafruit_Sensor.h>
#include <Adafruit_TSL2561_U.h>

Adafruit_TSL2561_Unified tsl = Adafruit_TSL2561_Unified(TSL2561_ADDR_LOW, 12345);


float sensor_tem,sensor_hum,sensor_lux,sensor_alt,sensor_pre;

void volcdsetup(char* zi,unsigned int x,unsigned int y)
{
  u8g.firstPage();  
  do {
    setFont_M;    
    u8g.setPrintPos(x, y); 
    u8g.print(zi);
  } 
  while( u8g.nextPage() );
}

void setup(void)
{
 
  Serial.begin(115200);

  Serial.println(bmp.begin() ? "BMP085 connection successful" : "BMP085 connection failed");
  Serial.println(tsl.begin() ? "TSL2561 connection successful" : "TSL2561 connection failed");

  /* You can also manually set the gain or enable auto-gain support */
  // tsl.setGain(TSL2561_GAIN_1X);      /* No gain ... use in bright light to avoid sensor saturation */
  // tsl.setGain(TSL2561_GAIN_16X);     /* 16x gain ... use in low light to boost sensitivity */
  tsl.enableAutoGain(true);          /* Auto-gain ... switches automatically between 1x and 16x */

  /* Changing the integration time gives you better sensor resolution (402ms = 16-bit data) */
  tsl.setIntegrationTime(TSL2561_INTEGRATIONTIME_13MS);      /* fast but low resolution */
  //tsl.setIntegrationTime(TSL2561_INTEGRATIONTIME_101MS);  /* medium resolution and speed   */
  //tsl.setIntegrationTime(TSL2561_INTEGRATIONTIME_402MS);  /* 16-bit data but slowest conversions */

  delay(500);
}



void loop(void)
{
  if (sensor_time > millis()) sensor_time = millis();
  if(millis()-sensor_time>INTERVAL_SENSOR)
  {
    {
      am2321.read();
      sensor_tem=am2321.temperature/10.0;
      sensor_hum=am2321.humidity/10.0;
    }
    {
      sensor_alt=bmp.readAltitude(101500);
      sensor_pre=bmp.readPressure();
    }
    {
      sensors_event_t event;
      tsl.getEvent(&event);

      /* Display the results (light is measured in lux) */
      if (event.light)
        sensor_lux=event.light;
      else
        Serial.println("Sensor overload");
    }
    sensor_time=millis();
  }


  if (lcd_time > millis()) lcd_time = millis();
  if(millis()-lcd_time>INTERVAL_LCD)
  {
    volcd();
    lcd_time=millis();
  }

}


void volcd()
{
  u8g.firstPage();  
  do {
    setFont_L;

    u8g.setPrintPos(0, 15*1); 
    u8g.print(sensor_tem ,1);
    u8g.print(" `C");
    u8g.print(" ");
    u8g.print(sensor_hum ,1);
    u8g.print(" %");

    u8g.setPrintPos(0, 15*2); 
    u8g.print(sensor_pre/1000.0 ,3);
    u8g.print(" kPa");

    /*
     u8g.setPrintPos(0, 15*4); 
     u8g.print(sensor_alt ,1);
     u8g.print(" Meters");
    */

    u8g.setPrintPos(0, 15*3); 
    u8g.print(sensor_lux ,1);
    u8g.print(" Lux");
  } 
  while( u8g.nextPage() );
}

